/*
Copyright 2021 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	rest "k8s.io/client-go/rest"
	v1 "knative.dev/eventing/pkg/apis/flows/v1"
	"knative.dev/eventing/pkg/client/clientset/versioned/scheme"
)

type FlowsV1Interface interface {
	RESTClient() rest.Interface
	ParallelsGetter
	SequencesGetter
}

// FlowsV1Client is used to interact with features provided by the flows.knative.dev group.
type FlowsV1Client struct {
	restClient rest.Interface
}

func (c *FlowsV1Client) Parallels(namespace string) ParallelInterface {
	return newParallels(c, namespace)
}

func (c *FlowsV1Client) Sequences(namespace string) SequenceInterface {
	return newSequences(c, namespace)
}

// NewForConfig creates a new FlowsV1Client for the given config.
func NewForConfig(c *rest.Config) (*FlowsV1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientFor(&config)
	if err != nil {
		return nil, err
	}
	return &FlowsV1Client{client}, nil
}

// NewForConfigOrDie creates a new FlowsV1Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *FlowsV1Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new FlowsV1Client for the given RESTClient.
func New(c rest.Interface) *FlowsV1Client {
	return &FlowsV1Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = scheme.Codecs.WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *FlowsV1Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
